import { Block, Popup, PopupContent, PopupHeader } from '@ensi-platform/core-components';
import { Row } from '@tanstack/react-table';
import { isEmpty } from 'lodash';
import { useCallback, useMemo, useState } from 'react';

import { Product, ProductFilter, useProducts, useProductsMeta, useProductsTypes } from '@api/catalog';

import { useError } from '@context/modal';

import LoadWrapper from '@controls/LoadWrapper';

import AutoFilters from '@components/AutoFilters';
import Table, { useSorting, useTable } from '@components/Table';
import { getSelectColumn, getSettingsColumn } from '@components/Table/columns';
import { TableEmpty, TableFooter, TableHeader } from '@components/Table/components';

import { LIMIT_PAGE } from '@scripts/constants';
import { Button, typography } from '@scripts/gds';
import { declOfNum, getPagination, getTotal, getTotalPages } from '@scripts/helpers';
import { useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

import PlusIcon from '@icons/plus.svg';

interface ConvertedProductData extends Omit<Product, 'type'> {
    type: number | string;
    customListLink: string;
}

export default function SelectProductsPopup({
    isOpen = false,
    onRequestClose,
    maxRowSelect = 0,
}: {
    isOpen: boolean;
    onRequestClose: (productIds: number[]) => void;
    maxRowSelect?: number;
}) {
    const [selectedFilter, setSelectedFilter] = useState<Partial<ProductFilter>>({});

    const { data: metaData, isFetching: isLoading, error } = useProductsMeta(isOpen);

    useError(error);

    const meta = useMemo(() => metaData?.data, [metaData?.data]);

    const {
        metaField,
        values,
        filtersActive,
        URLHelper,
        reset,
        searchRequestFilter,
        emptyInitialValues,
        codesToSortKeys,
        clearInitialValue,
        searchRequestIncludes,
    } = useAutoFilters(meta, { isSaveToUrl: false });

    const pageKey = 'select_products_popup';

    const [{ backendSorting }, sortingPlugin] = useSorting<Product>(pageKey, meta?.fields);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: meta?.default_sort,
        defaultPerPage: LIMIT_PAGE,
        codesToSortKeys,
    });

    const resetFilters = useCallback(() => {
        reset();
    }, [reset]);

    const autoGeneratedColumns = useAutoColumns(meta);

    const columns = useMemo(
        () => [
            getSelectColumn(maxRowSelect, 'select-product'),
            ...autoGeneratedColumns,
            getSettingsColumn({ columnsToDisable: [], visibleColumns: meta?.default_list }),
        ],
        [autoGeneratedColumns, maxRowSelect, meta?.default_list]
    );

    const {
        data: products,
        isFetching: isProductsLoading,
        error: productsError,
    } = useProducts(
        {
            filter: searchRequestFilter,
            sort: backendSorting,
            include: ['category', ...searchRequestIncludes],
            pagination: getPagination(activePage, itemsPerPageCount),
        },
        Boolean(meta) && !!backendSorting && isOpen
    );

    const productsData = useMemo(() => products?.data, [products?.data]);

    useError(productsError);

    const { data: apiTypes } = useProductsTypes(isOpen);

    const convertProductData = useMemo(
        () =>
            productsData?.map(item => ({
                ...item,
                id: item?.id,
                type: apiTypes?.data.find(elem => elem.id === item.type)?.name || '-',
                customListLink: '/products/catalog',
            })),
        [apiTypes?.data, productsData]
    );

    const productsTableData = useAutoTableData<ConvertedProductData>(convertProductData, metaField);

    const total = getTotal(products);
    const totalPages = getTotalPages(products, itemsPerPageCount);

    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total });

    const renderHeader = useCallback(
        (selectedRows: Row<ConvertedProductData>[]) => (
            <TableHeader>
                <div css={{ display: 'flex', justifyContent: 'space-between', width: '100%', padding: '0' }}>
                    <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                        Найдено {`${total} ${declOfNum(total, ['товар', 'товара', 'товаров'])}`}
                    </p>

                    {selectedRows?.length > 0 ? (
                        <Button
                            Icon={PlusIcon}
                            theme="primary"
                            type="submit"
                            onClick={() => {
                                const productIds = selectedRows?.map(
                                    (row: Row<ConvertedProductData>) => row.original.id
                                );

                                onRequestClose(productIds);
                            }}
                        >
                            Добавить{' '}
                            {`${selectedRows?.length} ${declOfNum(selectedRows?.length, [
                                'товар',
                                'товара',
                                'товаров',
                            ])}`}
                        </Button>
                    ) : null}
                </div>
            </TableHeader>
        ),
        [onRequestClose, total]
    );

    const table = useTable(
        {
            data: productsTableData,
            columns,
            meta: {
                tableKey: pageKey,
            },
        },
        [sortingPlugin]
    );

    return (
        <Popup
            open={isOpen}
            onClose={() => onRequestClose([])}
            size="screen_lg"
            innerScroll
            onUnmount={() => resetFilters()}
        >
            <PopupHeader title="Выберите товары для офферов" />
            <PopupContent>
                <LoadWrapper isLoading={isLoading || isProductsLoading}>
                    <AutoFilters
                        initialValues={values}
                        emptyInitialValues={emptyInitialValues}
                        onSubmit={v => {
                            URLHelper(v);
                        }}
                        onResetFilters={resetFilters}
                        filtersActive={filtersActive}
                        meta={meta}
                        clearInitialValue={clearInitialValue}
                    />

                    <Block>
                        <Block.Body>
                            {renderHeader(table.getSelectedRowModel().flatRows)}
                            <Table instance={table} />

                            {productsData?.length === 0 ? (
                                <TableEmpty
                                    filtersActive={!isEmpty(selectedFilter)}
                                    onResetFilters={() => setSelectedFilter({})}
                                    titleWithFilters="Товары не найдены"
                                    titleWithoutFilters="Товаров нет"
                                    addItems={() => setItemsPerPageCount(10)}
                                />
                            ) : (
                                <TableFooter
                                    pages={totalPages}
                                    itemsPerPageCount={itemsPerPageCount}
                                    setItemsPerPageCount={setItemsPerPageCount}
                                />
                            )}
                        </Block.Body>
                    </Block>
                </LoadWrapper>
            </PopupContent>
        </Popup>
    );
}
